"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var add_1 = require("../../setup/add");
var FeatureMessages = /** @class */ (function () {
    // eslint-disable-next-line no-empty-function
    function FeatureMessages(featureName) {
        var _this = this;
        this.featureName = featureName;
        this.exists = function () {
            return utils_1.error("\n    It seems like you already have this feature.\n        ");
        };
        this.invalidTemplate = function () {
            var highlightedFeatureName = utils_1.inverse(" " + _this.featureName + " ");
            return utils_1.error("\n    Invalid feature template.\n    Unfortunately, cli doesn't provide " + highlightedFeatureName + " feature template.\n    \n    Available feature templates: [" + Object.keys(add_1.featureSetup).join(', ') + "]\n        ");
        };
        this.generating = function () { return "Generating " + utils_1.info(_this.featureName) + " feature..."; };
        this.successful = function () { return "Added " + utils_1.success(_this.featureName) + " feature template"; };
        this.failed = function () {
            return "Failed to generate " + utils_1.error(_this.featureName) + " feature template";
        };
    }
    return FeatureMessages;
}());
exports.FeatureMessages = FeatureMessages;
